<?php
/**
 * Error Definitions
 *
 * $Id: definitions.errors.php 185 2007-05-10 22:44:39Z rbott $
 *
 * the following statements define all error codes
 * currently known to ZoneAdmin
 *
 * the error codes are seperated into multiple groups:
 *
 * 00000 - 00999 general Errors
 *
 * 01000 - 01999 zone-editing related errors
 *
 * 02000 - 02999 mysql related errors
 *
 * @author Rudolph Bott
 * @version 0.1
 * @copyright Rudolph Bott
 */

//general errors

/**
 * no Error
 *
 */
define('ERR_NOERROR',00000);

/**
 * a general, rather undefined error
 *
 */
define('ERR_GENERAL',00001);


//zone-editing related errors

/**
 * zone exists already
 */
define('ERR_ZONE_EXISTS',01001);

/**
 * zone has no soa record
 */
define('ERR_MISSING_SOA',01002);

/**
 * zone has an illegal soa record
 */
define('ERR_INVAL_SOA',01003);

/**
 * soa record contains non-standard serial
 */
define('ERR_INVAL_SERIAL',01004);

/**
 * an A record is still referenced in CNAME, MX or NS records
 */
define('ERR_HAS_REFS',01005);

/**
 * invalid and/or non-existant domain id
 */
define('ERR_INVAL_DOMAIN_ID',01006);

/**
 * invalid and/or non-existant domain-name
 */
define('ERR_INVAL_DOMAIN',01007);

/**
 * can not edit slave zone
 */
define('ERR_NO_EDIT_SLAVE',01008);


//record related errors

/**
 * invalid record data
 */
define('ERR_INVAL_RECORD',01101);

/**
 * invalid record name
 */
define('ERR_INVAL_NAME',01102);

/**
 * invalid record content
 */
define('ERR_INVAL_CONTENT',01103);

/**
 * invalid record priority
 */
define('ERR_INVAL_PRIO',01104);

/**
 * invalid record TTL
 */
define('ERR_INVAL_TTL',01105);


//mysql related errors

/**
 * a general mysql error occured
 */
define('ERR_MYSQL_GENERAL',02001);

/**
 * a (general) sql syntax error
 */
define('ERR_MYSQL_SYNTAX',02002);
?>
