<?php
/**
 * Provides functions to add/del/alter comments
 *
 * $Id: functions.comments.php 166 2007-04-16 08:33:54Z rbott $
 *
 * @package ZoneAdmin
 * @author Rudolph Bott
 * @version 0.1
 * @copyright Rudolph Bott
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License
 */


//nuetzliche funktionen fuer kommentare

/**
 * adds a comment to a record/zone
 *
 * the function saves a comment to the database
 * if valid zone, record and comment information have been passed to it
 * @param integer $zone the domain-id
 * @param integer $record the record-id
 * @param string $user currently logged in user
 * @param string $comment the actual comment
 * @return integer primary key of mysql insert operation
 * @author Rudolph Bott
 * @copyright Copyright 2007, Rudolph Bott
 * @version V1.0
*/
function add_comment($zone,$record,$user,$comment) {
  global $mysqlcfg;

  if(!empty($zone) && !empty($zone) && !empty($comment) && is_numeric($zone) && is_numeric($record)) {
    $query = "INSERT INTO ".$mysqlcfg["cmttbl"]." (`user`,`record_id`,`when`,`domain_id`,`msg`) VALUES('".mysql_real_escape_string($user)."','".mysql_real_escape_string($record)."',NOW(),'".mysql_real_escape_string($zone)."','".mysql_real_escape_string($comment)."')";
    mysql_query($query);
    return mysql_insert_id();
  }
}

/**
 * deletes a comment
 *
 * the function deletes a comment from the database
 * if valid zone, record and comment information have been passed to it
 * @param integer $zone the domain-id
 * @param integer $record the record-id
 * @return integer error number of the last mysql operation
 * @author Rudolph Bott
 * @copyright Copyright 2007, Rudolph Bott
 * @version V1.0
*/
function del_comment($zone,$record) {
  global $mysqlcfg;

  if(!empty($zone) && is_numeric($zone)) {
    $query = "DELETE FROM ".$mysqlcfg["cmttbl"]." WHERE domain_id='".mysql_real_escape_string($zone)."' AND record_id='".mysql_real_escape_string($record)."' LIMIT 1";
    mysql_query($query);
    return mysql_errno();
  }
}

/**
 * updates a comment in the database
 *
 * updates the values of a given comment in
 * the database
 * @param integer $zone the domain-id
 * @param integer $record the record-id
 * @param string $user currently logged in user
 * @param string $comment the actual comment
 * @return integer error-number of last mysql operation
 * @author Rudolph Bott
 * @copyright Copyright 2007, Rudolph Bott
 * @version V1.0
*/
function update_comment($zone,$record,$user,$comment) {
  global $mysqlcfg;

  if(!empty($zone) && !empty($zone) && !empty($comment) && is_numeric($zone) && is_numeric($record)) {
    $query = "UPDATE ".$mysqlcfg["cmttbl"]." SET `user`='".mysql_real_escape_string($user)."', `when`=NOW(), `msg`='".mysql_real_escape_string($comment)."' WHERE `record_id`='".mysql_real_escape_string($record)."' AND `domain_id`='".mysql_real_escape_string($zone)."'";
    mysql_query($query);
    return mysql_errno();
  }
}

/**
 * checks if a given comment exists
 *
 * returns true if given comment exists, otherwise false
 * @param integer $zone the domain-id
 * @param integer $record the record-id
 * @return boolean
 * @author Rudolph Bott
 * @copyright Copyright 2007, Rudolph Bott
 * @version V1.0
*/
function comment_exists($zone,$record) {
  global $mysqlcfg;

  $query = "SELECT id FROM ".$mysqlcfg["cmttbl"]." WHERE domain_id='".mysql_real_escape_string($zone)."' AND record_id='".mysql_real_escape_string($record)."'";
  $result = mysql_query($query);
  if(mysql_num_rows($result) > 0) {
    mysql_free_result($result);
    return true;
  }
  else {
    mysql_free_result($result);
    return false;
  }
}

/**
 * retrieves a given comment
 *
 * the function fetches the comment from the database
 * if valid zone and record information have been passed to it
 * @param integer $zone the domain-id
 * @param integer $record the record-id
 * @return array mysql row
 * @author Rudolph Bott
 * @copyright Copyright 2007, Rudolph Bott
 * @version V1.0
*/
function get_comment($zone,$record) {
  global $mysqlcfg;
  $comments = array();

  if(!empty($zone) && is_numeric($zone)) {
    $query = "SELECT * FROM ".$mysqlcfg["cmttbl"]." WHERE domain_id='".mysql_real_escape_string($zone)."' AND record_id='".mysql_real_escape_string($record)."'";
    $result = mysql_query($query);
    $comments = mysql_fetch_assoc($result);
    mysql_free_result($result);
  }

  return $comments;
}

/**
 * retrieves comments for a given zone
 *
 * the function fetches all comments for a given zone
 * if valid zone information have been passed to it
 * @param integer $zone the domain-id
 * @return array 2-dimensional array of mysql rows 
 * @author Rudolph Bott
 * @copyright Copyright 2007, Rudolph Bott
 * @version V1.0
*/

function get_comments($zone) {
  global $mysqlcfg;
  $comments = array();

  if(!empty($zone) && is_numeric($zone)) {
    $query = "SELECT * FROM ".$mysqlcfg["cmttbl"]." WHERE domain_id='".mysql_real_escape_string($zone)."' ORDER BY `when` DESC";
    $result = mysql_query($query);
    while($row = mysql_fetch_assoc($result)) {
      $comments[] = $row;
    }
    mysql_free_result($result);
  }

  return $comments;
}

?>
